<?php
	
	//	é
	
	include_once( realpath( dirname(__FILE__) ) . "/../../../classes/PluginsClassiques.class.php" );
	include_once( realpath( dirname(__FILE__) ) . "/Cnxlibre.class.php" );
	
	function comparaisonLongueursChaines( $chaine1, $chaine2 ) {
	
		$taille1 = strlen($chaine1);
		$taille2 = strlen($chaine2);
		return ( $taille1 < $taille2 ) ? 1 : -1;
	}
	
	class Bouclelibre extends PluginsClassiques {
	
		public function __construct() {
		
			parent::__construct("bouclelibre");	
		}
		
		public function boucle( $texte , $args ) {
		
			$retourner = "";
			
			//	Base & Boucle concernées
			$base = strtolower( lireTag( $args , "base" ) );
			$boucle = lireTag( $args , "boucle" );
			
			//	Boucle doit être spécifié
			if ( empty( $boucle ) ) {
			
				return "";
			}
			
			//	On récupère la notre instance Cnxlibre qui nous permet de faire des requêtes
			$execute = CnxlibreStatique::getBase( $base );
			if ( $execute === false ) {
			
				return "";
			}
			
			//	On détermine le nom des colonnes
			$listeColonnes = $execute->listeColonnes( $boucle );
			
			$sql = "
				SELECT
					*
				FROM
					`" . $boucle . "`
				WHERE
					1
			";
			$valeurs = array();
			
			//	On ajoute les éventuels critères
			foreach ( $listeColonnes as $colonne ) {
			
				//	Si le libelle en entier du critère est trouvé dans la chaine d'arguments de la boucle
				$critere = " " . $colonne . "=";
				
				if (  strpos( $args , $critere ) ) {
				
					$valeurCritere = lireTag( $args , $colonne );
					
					$sql .= "
					  AND
						" . $colonne . " = :" . $colonne . "
					";
					
					$valeurs[$colonne] = $valeurCritere;
				}
			}
			
			//	Clause ORDER BY (aléatoire, manuel, inverse)
			$libelleClassement = $this->critereUnique( $listeColonnes, 'classement' );
			$classement = lireTag( $args , $libelleClassement );
			
			if ( !empty( $classement ) ) {
			
				$classements = explode( ',', $classement );
				
				$order = "";
				$sens = "ASC";
				
				foreach ( $classements as $classement ) {
				
					$libelleAleatoire = $this->critereUnique( $listeColonnes, 'aléatoire' );
					$libelleManuel = $this->critereUnique( $listeColonnes, 'manuel' );
					$libelleInverse = $this->critereUnique( $listeColonnes, 'inverse' );
					
					if ( $classement == $libelleAleatoire ) {
					
						$order .= ( $order != '' ) ? ',' : '';
						$order .= " RAND()";
					}
					elseif ( $classement == $libelleManuel ) {
						
						if ( in_array( 'classement' , $listeColonnes ) ) {
						
							$order .= ( $order != '' ) ? ',' : '';
							$order .= " classement";
						}
					}
					elseif ( $classement == $libelleInverse ) {
						
						$sens = "DESC";
					}
					
					if ( in_array( $classement , $listeColonnes ) ) {
					
						$order .= ( $order != '' ) ? ',' : '';
						$order .= " " . $classement;
					}
				}
				
				if ( !empty( $order ) ) {
				
					$sql .= "
						ORDER BY
							" . $order . "
						" . $sens . "
					";
				}
			}
			
			//	Clause LIMIT ( LIMIT [deb,] num )
			
			//	num : Nombre d'occurences
			$libelleNum = $this->critereUnique( $listeColonnes, 'num' );
			$num = lireTag( $args , $libelleNum );
			
			//	deb : Positionnement dans la recherche
			$libelleDeb = $this->critereUnique( $listeColonnes, 'deb' );
			$deb = lireTag( $args , $libelleDeb );
			
			if ( !empty( $num ) ) {
				
				$limit = (int) $num;
				if ( !empty( $deb ) ) {
				
					$limit = intval( $deb ) . ',' . intval( $num );
				}
				
				$sql .= "
					LIMIT
						" . $limit . "
				";
			}
			
			//	Pour ne pas couper la mauvaise balise (#NO au lieu de #NOM par exemple)
			usort( $listeColonnes, 'comparaisonLongueursChaines' );
			
			$compteur = 0;
			foreach ( $execute->listeTableaux( $sql, $valeurs ) as $ligne ) {
				
				$compteur++;
				$temp = $texte;
				
				foreach ( $listeColonnes as $colonne ) {
				
					$temp = str_replace( "#" . strtoupper( $colonne ) , $ligne[$colonne] , $temp );
				}
				$temp = str_replace( "#COMPT" , $compteur , $temp );
				
				$retourner .= $temp;
			}
			
			return $retourner;
		}
		
		protected function critereUnique( &$listeColonnes , $libelleColonne ) {
			
			if ( in_array( $libelleColonne, $listeColonnes ) ) {
			
				$libelleColonne .= "_bouclelibre";
			}
			return $libelleColonne;
		}
	}
